searchData={"items":[{"type":"module","title":"KinoMembrane","doc":"Membrane Kino dashboard utilities.","ref":"KinoMembrane.html"},{"type":"function","title":"KinoMembrane.pipeline_dashboard/2","doc":"Displays a pipeline dashboard, containing a `KinoMembrane.PipelineGraph`\nand `KinoMembrane.PipelineTree`.\n\nClicking on an element in the graph or tree opens `KinoMembrane.ComponentInfo`\ndisplaying details & metrics for that element.\n\nFor usage example, see Readme.","ref":"KinoMembrane.html#pipeline_dashboard/2"},{"type":"function","title":"KinoMembrane.pipeline_graph/1","doc":"","ref":"KinoMembrane.html#pipeline_graph/1"},{"type":"function","title":"KinoMembrane.pipeline_tree/2","doc":"","ref":"KinoMembrane.html#pipeline_tree/2"},{"type":"module","title":"KinoMembrane.ComponentInfo","doc":"Kino that displays information about a Membrane component.\n\nIt shows the component path, pads, charts with metrics and more -\nbetter check it yourself by clicking an element on the `KinoMembrane.PipelineGraph`\nor `KinoMembrane.PipelineTree`.\n\nCurrently it supports elements only.","ref":"KinoMembrane.ComponentInfo.html"},{"type":"function","title":"KinoMembrane.ComponentInfo.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"KinoMembrane.ComponentInfo.html#child_spec/1"},{"type":"function","title":"KinoMembrane.ComponentInfo.new/1","doc":"","ref":"KinoMembrane.ComponentInfo.html#new/1"},{"type":"function","title":"KinoMembrane.ComponentInfo.set_component/2","doc":"","ref":"KinoMembrane.ComponentInfo.html#set_component/2"},{"type":"type","title":"KinoMembrane.ComponentInfo.t/0","doc":"","ref":"KinoMembrane.ComponentInfo.html#t:t/0"},{"type":"module","title":"KinoMembrane.PipelineGraph","doc":"Displays a graph of the given pipeline.\n\nThe graph allows to:\n\n  - Zoom in/out using mouse scroll (after clicking the graph at least once)\n  - Expand bins (the green squares) by either clicking + or double tapping (this will zoom in to fit the expanded bin as well)\n  - Move components when holding Alt/Option\n  - Select multiple components when holding Shift\n  - If the layout is not readable enough, clicking Refresh layout may help\n  - Clicking on a component reveals it in a component info view below the graph\n  - Clicking the zoom (+) button of the Livebook cell extends the graph to cover full page width","ref":"KinoMembrane.PipelineGraph.html"},{"type":"function","title":"KinoMembrane.PipelineGraph.new/2","doc":"","ref":"KinoMembrane.PipelineGraph.html#new/2"},{"type":"module","title":"KinoMembrane.PipelineTree","doc":"Pipeline tree is a simple tree view that allows to explore a pipeline in a parent-child manner.\n\nBy default it shows top-level elements and bins, and once you click on a bin it reveals its children.\nClicking on an element reveals it in a component info view below the tree.","ref":"KinoMembrane.PipelineTree.html"},{"type":"function","title":"KinoMembrane.PipelineTree.new/2","doc":"","ref":"KinoMembrane.PipelineTree.html#new/2"},{"type":"extras","title":"Kino Membrane","doc":"# Kino Membrane\n\n[![Hex.pm](https://img.shields.io/hexpm/v/kino_membrane.svg)](https://hex.pm/packages/kino_membrane)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/kino_membrane)\n[![CircleCI](https://circleci.com/gh/membraneframework/kino_membrane.svg?style=svg)](https://circleci.com/gh/membraneframework/kino_membrane)\n\nUtilities for introspecting [Membrane](https://membrane.stream) pipelines in [Livebook](https://livebook.dev/).","ref":"readme.html"},{"type":"extras","title":"Installation - Kino Membrane","doc":"The package can be installed by adding `kino_membrane` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:kino_membrane, \"~> 0.1.0\"}\n  ]\nend\n```\n\nor by calling\n\n```elixir\nMix.install([:kino_membrane])\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Kino Membrane","doc":"To run the pipeline dashboard, install `:kino_membrane` as described above, and type the following in a [Livebook](https://livebook.dev/) cell:\n\n```elixir\nKinoMembrane.pipeline_dashboard(pipeline)\n```\n\nThe pipeline can either be started within the Livebook (see [example](examples/pipeline_in_livebook.livemd)) or you can connect to a node where the pipeline is running (see [example](examples/connect_to_node.livemd)).","ref":"readme.html#usage"},{"type":"extras","title":"Development - Kino Membrane","doc":"This package contains JavaScript subproject. It's precompiled, so you only need to compile them if you change its code or need to generate a source map. In that case, run\n\n```sh\nmix setup # fetches JS and Elixir deps\nmix build # compiles JS and Elixir code\n```\n\nor compile each project manually\n\n```sh\nnpm ci --prefix assets\nnpm run build --prefix assets\nmix deps.get\nmix compile\n```","ref":"readme.html#development"},{"type":"extras","title":"Copyright and License - Kino Membrane","doc":"Copyright 2020, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=kino_membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=kino_membrane)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2020 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"},{"type":"extras","title":"Connect to node - dashboard example","doc":"# Connect to node - dashboard example\n\n```elixir\nMix.install([\n  :kino_membrane\n])\n```","ref":"connect_to_node.html"},{"type":"extras","title":"Dashboard - Connect to node - dashboard example","doc":"To be able to connect to a running node, it should be started in the distributed mode. For example, instead of\n\n```sh\nmix phx.server\n```\n\ntype\n\n```sh\nelixir --sname sid --cookie monster -S mix phx.server\n```\n\nThen, you can connect to the node with the following code:\n\n```elixir\n# If the node is not running locally, provide its hostname instead\n{:ok, hostname} = :inet.gethostname()\nnode = :\"sid@#{hostname}\"\nNode.set_cookie(node, :monster)\nstatus = Node.connect(node)\n\nif status == false do\n  raise \"Couldn't connect to the node #{inspect(node)}\"\nend\n\n:ok\n```\n\nNow you can show a dashboard for a pipeline running on the node. The snippet below lists all the running pipelines and displays the dashboard for one of them.\n\n```elixir\ncase Membrane.Pipeline.list_pipelines(node) do\n  [pipeline | _pipelines] -> KinoMembrane.pipeline_dashboard(pipeline)\n  [] -> raise \"No running pipelines found in the node #{inspect(node)}\"\nend\n```","ref":"connect_to_node.html#dashboard"},{"type":"extras","title":"Pipeline in livebook - dashboard example","doc":"# Pipeline in livebook - dashboard example\n\n```elixir\nLogger.configure(level: :info)\n\nMix.install([\n  :kino_membrane,\n  :membrane_hackney_plugin,\n  :membrane_portaudio_plugin,\n  :membrane_ffmpeg_swresample_plugin,\n  :membrane_mp3_mad_plugin\n])\n```","ref":"pipeline_in_livebook.html"},{"type":"extras","title":"Prerequisities - Pipeline in livebook - dashboard example","doc":"Make sure you have the following libraries installed on your OS:\n\n```\nclang-format, portaudio19-dev, FFmpeg 4.*, libavutil-dev, libswresample-dev, libmad0-dev\n```\n\nOn Mac OS, you can install them via Homebrew:\n```\nbrew install clang-format portaudio ffmpeg libmad pkg-config\n```\n\nand on Debian via apt:\n```\napt install clang-format portaudio19-dev ffmpeg libavutil-dev libswresample-dev libmad0-dev\n```","ref":"pipeline_in_livebook.html#prerequisities"},{"type":"extras","title":"Dashboard - Pipeline in livebook - dashboard example","doc":"```elixir\nimport Membrane.ChildrenSpec\nalias Membrane.RCPipeline\n\npipeline = RCPipeline.start_link!()\n\nRCPipeline.exec_actions(pipeline,\n  spec:\n    child(:hackney, %Membrane.Hackney.Source{\n      location:\n        \"https://raw.githubusercontent.com/membraneframework/membrane_demo/master/simple_pipeline/sample.mp3\",\n      hackney_opts: [follow_redirect: true]\n    })\n    |> via_in(:input, auto_demand_size: 10)\n    |> child(:decoder, Membrane.MP3.MAD.Decoder)\n    |> child(:converter, %Membrane.FFmpeg.SWResample.Converter{\n      output_stream_format: %Membrane.RawAudio{\n        sample_format: :s16le,\n        sample_rate: 48000,\n        channels: 2\n      }\n    })\n    |> child(:portaudio, Membrane.PortAudio.Sink),\n  playback: :playing\n)\n```\n\n```elixir\nKinoMembrane.pipeline_dashboard(pipeline)\n```\n\n```elixir\nMembrane.Pipeline.terminate(pipeline)\n```","ref":"pipeline_in_livebook.html#dashboard"}],"content_type":"text/markdown"}