searchNodes=[{"type":"module","title":"KinoMembrane","doc":"Membrane Kino dashboard utilities.","ref":"KinoMembrane.html"},{"type":"function","title":"KinoMembrane.pipeline_dashboard/2","doc":"Displays a pipeline dashboard, containing a KinoMembrane.PipelineGraph and KinoMembrane.PipelineTree . Clicking on an element in the graph or tree opens KinoMembrane.ComponentInfo displaying details &amp; metrics for that element. For usage example, see Readme.","ref":"KinoMembrane.html#pipeline_dashboard/2"},{"type":"function","title":"KinoMembrane.pipeline_graph/1","doc":"See KinoMembrane.PipelineGraph.new/1 .","ref":"KinoMembrane.html#pipeline_graph/1"},{"type":"function","title":"KinoMembrane.pipeline_tree/2","doc":"See KinoMembrane.PipelineTree.new/2 .","ref":"KinoMembrane.html#pipeline_tree/2"},{"type":"module","title":"KinoMembrane.ComponentInfo","doc":"Kino that displays information about a Membrane component. It shows the component path, pads, charts with metrics and more - better check it yourself by clicking an element on the KinoMembrane.PipelineGraph or KinoMembrane.PipelineTree . Currently it supports elements only.","ref":"KinoMembrane.ComponentInfo.html"},{"type":"function","title":"KinoMembrane.ComponentInfo.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"KinoMembrane.ComponentInfo.html#child_spec/1"},{"type":"function","title":"KinoMembrane.ComponentInfo.new/1","doc":"","ref":"KinoMembrane.ComponentInfo.html#new/1"},{"type":"function","title":"KinoMembrane.ComponentInfo.set_component/2","doc":"","ref":"KinoMembrane.ComponentInfo.html#set_component/2"},{"type":"type","title":"KinoMembrane.ComponentInfo.t/0","doc":"","ref":"KinoMembrane.ComponentInfo.html#t:t/0"},{"type":"module","title":"KinoMembrane.PipelineGraph","doc":"Displays a graph of the given pipeline. The graph allows to: Zoom in/out using mouse scroll (after clicking the graph at least once) Expand bins (the green squares) by either clicking + or double tapping (this will zoom in to fit the expanded bin as well) Move components when holding Alt/Option Select multiple components when holding Shift If the layout is not readable enough, clicking Refresh layout may help Clicking on a component reveals it in a component info view below the graph Clicking the zoom (+) button of the Livebook cell extends the graph to cover full page width","ref":"KinoMembrane.PipelineGraph.html"},{"type":"function","title":"KinoMembrane.PipelineGraph.new/2","doc":"","ref":"KinoMembrane.PipelineGraph.html#new/2"},{"type":"module","title":"KinoMembrane.PipelineTree","doc":"Pipeline tree is a simple tree view that allows to explore a pipeline in a parent-child manner. By default it shows top-level elements and bins, and once you click on a bin it reveals its children. Clicking on an element reveals it in a component info view below the tree.","ref":"KinoMembrane.PipelineTree.html"},{"type":"function","title":"KinoMembrane.PipelineTree.new/2","doc":"","ref":"KinoMembrane.PipelineTree.html#new/2"},{"type":"extras","title":"Kino Membrane","doc":"Utilities for introspecting Membrane pipelines in Livebook .","ref":"readme.html"},{"type":"extras","title":"Kino Membrane - Installation","doc":"The package can be installed by adding kino_membrane to your list of dependencies in mix.exs : def deps do [ { :kino_membrane , &quot;~&gt; 0.1.0&quot; } ] end or by calling Mix . install ( [ :kino_membrane ] )","ref":"readme.html#installation"},{"type":"extras","title":"Kino Membrane - Usage","doc":"To run the pipeline dashboard, install :kino_membrane as described above, and type the following in a Livebook cell: KinoMembrane . pipeline_dashboard ( pipeline ) The pipeline can either be started within the Livebook (see example ) or you can connect to a node where the pipeline is running (see example ).","ref":"readme.html#usage"},{"type":"extras","title":"Kino Membrane - Development","doc":"This package contains JavaScript subproject. It's precompiled, so you only need to compile them if you change its code or need to generate a source map. In that case, run mix setup # fetches JS and Elixir deps mix build # compiles JS and Elixir code or compile each project manually npm ci --prefix assets npm run build --prefix assets mix deps.get mix compile","ref":"readme.html#development"},{"type":"extras","title":"Kino Membrane - Copyright and License","doc":"Copyright 2020, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"},{"type":"extras","title":"Connect to node - dashboard example","doc":"Mix . install ( [ :kino_membrane ] )","ref":"connect_to_node.html"},{"type":"extras","title":"Connect to node - dashboard example - Dashboard","doc":"To be able to connect to a running node, it should be started in the distributed mode. For example, instead of mix phx.server type elixir --sname sid --cookie monster -S mix phx.server Then, you can connect to the node with the following code: # If the node is not running locally, provide its hostname instead { :ok , hostname } = :inet . gethostname ( ) node = :&quot;sid@ \#{ hostname } &quot; Node . set_cookie ( node , :monster ) status = Node . connect ( node ) if status == false do raise &quot;Couldn&#39;t connect to the node \#{ inspect ( node ) } &quot; end :ok Now you can show a dashboard for a pipeline running on the node. The snippet below lists all the running pipelines and displays the dashboard for one of them. case Membrane.Pipeline . list_pipelines ( node ) do [ pipeline | _pipelines ] -&gt; KinoMembrane . pipeline_dashboard ( pipeline ) [ ] -&gt; raise &quot;No running pipelines found in the node \#{ inspect ( node ) } &quot; end","ref":"connect_to_node.html#dashboard"},{"type":"extras","title":"Pipeline in livebook - dashboard example","doc":"Logger . configure ( level : :info ) Mix . install ( [ :kino_membrane , :membrane_hackney_plugin , :membrane_portaudio_plugin , :membrane_ffmpeg_swresample_plugin , :membrane_mp3_mad_plugin ] )","ref":"pipeline_in_livebook.html"},{"type":"extras","title":"Pipeline in livebook - dashboard example - Prerequisities","doc":"Make sure you have the following libraries installed on your OS: clang - format , portaudio19 - dev , FFmpeg 4 . * , libavutil - dev , libswresample - dev , libmad0 - dev On Mac OS, you can install them via Homebrew: brew install clang - format portaudio ffmpeg libmad pkg - config and on Debian via apt: apt install clang - format portaudio19 - dev ffmpeg libavutil - dev libswresample - dev libmad0 - dev","ref":"pipeline_in_livebook.html#prerequisities"},{"type":"extras","title":"Pipeline in livebook - dashboard example - Dashboard","doc":"import Membrane.ChildrenSpec alias Membrane.RCPipeline pipeline = RCPipeline . start_link! ( ) RCPipeline . exec_actions ( pipeline , spec : child ( :hackney , % Membrane.Hackney.Source { location : &quot;https://raw.githubusercontent.com/membraneframework/membrane_demo/master/simple_pipeline/sample.mp3&quot; , hackney_opts : [ follow_redirect : true ] } ) |&gt; via_in ( :input , auto_demand_size : 10 ) |&gt; child ( :decoder , Membrane.MP3.MAD.Decoder ) |&gt; child ( :converter , % Membrane.FFmpeg.SWResample.Converter { output_stream_format : % Membrane.RawAudio { sample_format : :s16le , sample_rate : 48000 , channels : 2 } } ) |&gt; child ( :portaudio , Membrane.PortAudio.Sink ) , playback : :playing ) KinoMembrane . pipeline_dashboard ( pipeline ) Membrane.Pipeline . terminate ( pipeline )","ref":"pipeline_in_livebook.html#dashboard"}]